// GENERATED CODE - DO NOT MODIFY BY HAND

part of 'item_api.dart';

// **************************************************************************
// JaguarHttpGenerator
// **************************************************************************

abstract class _$ItemApiClient implements ApiClient {
  final String basePath = "";
  Future<Item> createItem(
      String authorization, String xAPIKey, Item body) async {
    var req = base.post
        .metadata({
          "auth": [
            {
              "type": "apiKey",
              "name": "JWT",
              "keyName": "Authorization",
              "where": "header",
            }
          ],
        })
        .path(basePath)
        .path("/item")
        .header("Authorization", authorization)
        .header("X-API-Key", xAPIKey)
        .json(jsonConverter.to(body));
    return req.go(throwOnErr: true).map(decodeOne);
  }

  Future<Item> createItemImage(String id, String authorization, String xAPIKey,
      MultipartFile file, bool isMain) async {
    var req = base.post
        .metadata({
          "auth": [
            {
              "type": "apiKey",
              "name": "JWT",
              "keyName": "Authorization",
              "where": "header",
            }
          ],
        })
        .path(basePath)
        .path("/item/:id/image")
        .pathParams("id", id)
        .header("Authorization", authorization)
        .header("X-API-Key", xAPIKey)
        .multipart({"file": file})
        .multipart({"isMain": isMain});
    return req.go(throwOnErr: true).map(decodeOne);
  }

  Future<void> deleteItemByID(
      String id, String authorization, String xAPIKey) async {
    var req = base.delete
        .metadata({
          "auth": [
            {
              "type": "apiKey",
              "name": "JWT",
              "keyName": "Authorization",
              "where": "header",
            }
          ],
        })
        .path(basePath)
        .path("/item/:id")
        .pathParams("id", id)
        .header("Authorization", authorization)
        .header("X-API-Key", xAPIKey);
    await req.go(throwOnErr: true);
  }

  Future<void> deleteItemImageByID(
      String id, String imageId, String authorization, String xAPIKey) async {
    var req = base.delete
        .metadata({
          "auth": [
            {
              "type": "apiKey",
              "name": "JWT",
              "keyName": "Authorization",
              "where": "header",
            }
          ],
        })
        .path(basePath)
        .path("/item/:id/image/:imageId")
        .pathParams("id", id)
        .pathParams("imageId", imageId)
        .header("Authorization", authorization)
        .header("X-API-Key", xAPIKey);
    await req.go(throwOnErr: true);
  }

  Future<List<Item>> findItem(String authorization, String xAPIKey, num limit,
      num offset, String sort, String direction, List<String> filter) async {
    var req = base.get
        .metadata({
          "auth": [
            {
              "type": "apiKey",
              "name": "JWT",
              "keyName": "Authorization",
              "where": "header",
            }
          ],
        })
        .path(basePath)
        .path("/item")
        .query("limit", limit)
        .query("offset", offset)
        .query("sort", sort)
        .query("direction", direction)
        .query("filter", filter)
        .header("Authorization", authorization)
        .header("X-API-Key", xAPIKey);
    return req.go(throwOnErr: true).map(decodeList);
  }

  Future<Item> getItemByID(
      String id, String authorization, String xAPIKey) async {
    var req = base.get
        .metadata({
          "auth": [
            {
              "type": "apiKey",
              "name": "JWT",
              "keyName": "Authorization",
              "where": "header",
            }
          ],
        })
        .path(basePath)
        .path("/item/:id")
        .pathParams("id", id)
        .header("Authorization", authorization)
        .header("X-API-Key", xAPIKey);
    return req.go(throwOnErr: true).map(decodeOne);
  }

  Future<Item> updateItemByID(
      String id, String authorization, String xAPIKey, Item body) async {
    var req = base.put
        .metadata({
          "auth": [
            {
              "type": "apiKey",
              "name": "JWT",
              "keyName": "Authorization",
              "where": "header",
            }
          ],
        })
        .path(basePath)
        .path("/item/:id")
        .pathParams("id", id)
        .header("Authorization", authorization)
        .header("X-API-Key", xAPIKey)
        .json(jsonConverter.to(body));
    return req.go(throwOnErr: true).map(decodeOne);
  }

  Future<Item> updateItemImageByID(
      String id,
      String imageId,
      String authorization,
      String xAPIKey,
      MultipartFile file,
      bool isMain) async {
    var req = base.put
        .metadata({
          "auth": [
            {
              "type": "apiKey",
              "name": "JWT",
              "keyName": "Authorization",
              "where": "header",
            }
          ],
        })
        .path(basePath)
        .path("/item/:id/image/:imageId")
        .pathParams("id", id)
        .pathParams("imageId", imageId)
        .header("Authorization", authorization)
        .header("X-API-Key", xAPIKey)
        .multipart({"file": file})
        .multipart({"isMain": isMain});
    return req.go(throwOnErr: true).map(decodeOne);
  }
}
