import 'package:jaguar_serializer/jaguar_serializer.dart';


import 'package:pointpos_api/model/image.dart';

import 'package:pointpos_api/model/item_cost_of_goods_sold.dart';

import 'package:pointpos_api/model/item_variants.dart';

import 'package:pointpos_api/model/item_inventory.dart';

part 'item.jser.dart';

class Item {
  
  @Alias('id', isNullable: false,  )
  final String id;
  
  @Alias('name', isNullable: false,  )
  final String name;
  
  @Alias('categoryId', isNullable: false,  )
  final num categoryId;
  
  @Alias('images', isNullable: false,  )
  final List<Image> images;
  
  @Alias('variants', isNullable: false,  )
  final List<ItemVariants> variants;
  
  @Alias('inventory', isNullable: false,  )
  final List<ItemInventory> inventory;
  
  @Alias('costOfGoodsSold', isNullable: false,  )
  final List<ItemCostOfGoodsSold> costOfGoodsSold;
  
  @Alias('description', isNullable: false,  )
  final String description;
  

  Item(
      

{
     this.id = null,  
    
     this.name = null,  
     this.categoryId = null,   this.images = const [],  
    
     this.variants = const [],  
     this.inventory = const [],  
     this.costOfGoodsSold = const [],   this.description = null 
    
    }
  );

  @override
  String toString() {
    return 'Item[id=$id, name=$name, categoryId=$categoryId, images=$images, variants=$variants, inventory=$inventory, costOfGoodsSold=$costOfGoodsSold, description=$description, ]';
  }
}

@GenSerializer(nullableFields: true)
class ItemSerializer extends Serializer<Item> with _$ItemSerializer {

}

