import 'package:jaguar_serializer/jaguar_serializer.dart';


import 'package:pointpos_api/model/loyalty_program_point_from_total_spent.dart';

import 'package:pointpos_api/model/loyalty_program_redeem_rules.dart';

import 'package:pointpos_api/model/loyalty_program_point_from_buy_item.dart';

part 'loyalty_program.jser.dart';

class LoyaltyProgram {
  
  @Alias('id', isNullable: false,  )
  final String id;
  
  @Alias('name', isNullable: false,  )
  final String name;
  
  @Alias('pointFromTotalSpent', isNullable: false,  )
  final LoyaltyProgramPointFromTotalSpent pointFromTotalSpent;
  
  @Alias('pointFromBuyItem', isNullable: false,  )
  final LoyaltyProgramPointFromBuyItem pointFromBuyItem;
  
  @Alias('newMemberPoint', isNullable: false,  )
  final num newMemberPoint;
  
  @Alias('redeemRules', isNullable: false,  )
  final List<LoyaltyProgramRedeemRules> redeemRules;
  

  LoyaltyProgram(
      

{
     this.id = null,  
    
     this.name = null,  
     this.pointFromTotalSpent = null,  
     this.pointFromBuyItem = null,  
     this.newMemberPoint = null,  
     this.redeemRules = const [] 
    }
  );

  @override
  String toString() {
    return 'LoyaltyProgram[id=$id, name=$name, pointFromTotalSpent=$pointFromTotalSpent, pointFromBuyItem=$pointFromBuyItem, newMemberPoint=$newMemberPoint, redeemRules=$redeemRules, ]';
  }
}

@GenSerializer(nullableFields: true)
class LoyaltyProgramSerializer extends Serializer<LoyaltyProgram> with _$LoyaltyProgramSerializer {

}

