import 'package:jaguar_serializer/jaguar_serializer.dart';


import 'package:pointpos_api/model/order_discounts.dart';

import 'package:pointpos_api/model/order_modifiers.dart';

part 'order_items.jser.dart';

class OrderItems {
  
  @Alias('itemId', isNullable: false,  )
  final String itemId;
  
  @Alias('variantId', isNullable: false,  )
  final num variantId;
  
  @Alias('modifiers', isNullable: false,  )
  final List<OrderModifiers> modifiers;
  
  @Alias('discounts', isNullable: false,  )
  final List<OrderDiscounts> discounts;
  
  @Alias('salesTypeId', isNullable: false,  )
  final String salesTypeId;
  
  @Alias('note', isNullable: false,  )
  final String note;
  
  @Alias('qty', isNullable: false,  )
  final num qty;
  
  @Alias('subTotal', isNullable: false,  )
  final num subTotal;
  

  OrderItems(
      

{
     this.itemId = null,  
     this.variantId = null,  
     this.modifiers = const [],  
     this.discounts = const [],  
     this.salesTypeId = null,  
     this.note = null,  
     this.qty = null,  
     this.subTotal = null 
    
    }
  );

  @override
  String toString() {
    return 'OrderItems[itemId=$itemId, variantId=$variantId, modifiers=$modifiers, discounts=$discounts, salesTypeId=$salesTypeId, note=$note, qty=$qty, subTotal=$subTotal, ]';
  }
}

@GenSerializer(nullableFields: true)
class OrderItemsSerializer extends Serializer<OrderItems> with _$OrderItemsSerializer {

}

