import 'package:jaguar_serializer/jaguar_serializer.dart';


part 'role_permission.jser.dart';

class RolePermission {
  
  @Alias('id', isNullable: false,  )
  final String id;
  
  @Alias('priority_rank', isNullable: false,  )
  final num priorityRank;
  
  @Alias('menu', isNullable: false,  )
  final String menu;
  
  @Alias('menu_name', isNullable: false,  )
  final String menuName;
  
  @Alias('access', isNullable: false,  )
  final String access;
  
  @Alias('pin_required', isNullable: false,  )
  final bool pinRequired;
  
  @Alias('mobile_supported', isNullable: false,  )
  final bool mobileSupported;
  
  @Alias('usable', isNullable: false,  )
  final bool usable;
  
  @Alias('urls', isNullable: false,  )
  final List<String> urls;
  
  @Alias('sub_menu', isNullable: false,  )
  final String subMenu;
  
  @Alias('sub_menu_name', isNullable: false,  )
  final String subMenuName;
  
  @Alias('is_allowed_for_point_pay', isNullable: false,  )
  final bool isAllowedForPointPay;
  

  RolePermission(
      

{
     this.id = null,  
    
     this.priorityRank = null,  
     this.menu = null,  
     this.menuName = null,  
     this.access = null,  
     this.pinRequired = null,  
     this.mobileSupported = null,  
     this.usable = null,  
     this.urls = const [],  
     this.subMenu = null,  
     this.subMenuName = null,  
     this.isAllowedForPointPay = null 
    }
  );

  @override
  String toString() {
    return 'RolePermission[id=$id, priorityRank=$priorityRank, menu=$menu, menuName=$menuName, access=$access, pinRequired=$pinRequired, mobileSupported=$mobileSupported, usable=$usable, urls=$urls, subMenu=$subMenu, subMenuName=$subMenuName, isAllowedForPointPay=$isAllowedForPointPay, ]';
  }
}

@GenSerializer(nullableFields: true)
class RolePermissionSerializer extends Serializer<RolePermission> with _$RolePermissionSerializer {

}

